C
C
C
C               MAIN PROGRAMME FOR PROBLEM "C1_V1.FOR"
C
C     - CONSTRAINED
C
C     W. R. KLINGMAN AND D. M. HIMMELBLAU: "NONLINEAR PROGRAMMING
C           WITH THE AID OF A MULTIPLE-GRADIENT SUMMATION TECHNIQUE",
C           JOURNAL OF THE ASSOCIATION FOR COMPUTING MACHINERY, 1964,
C           11, (4), PP.400 - 415.
C
      DOUBLE PRECISION C(2),FF(4),H(8),XDN(2),XG(2),XMAX(2),XMIN(2),
     1XT(2),XUP(2),XX(1),XXMAX(1),XXMIN(1),OLDCC(2)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
 
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=1.D0
      XT(2)=1.D0
C
C     CONTROL PARAMETERS FOR "EVOP"
C
      ALPHA=1.3D0
      BETA=0.3D0
      GAMA=2.D0
      DEL=1.D-10
      PHI=1.D-10
      PHICPX=1.D-10
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,
     2XUP,XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMISATION OF TEST PROBLEM: "C1_V1.FOR"'//)
  998 FORMAT(1X,' W. R. KLINGMAN AND D. M. HIMMELBLAU: "NONLINEAR PROGR'
     1,'AMMING WITH'/1X,'THE AID OF A MULTIPLE-GRADIENT SUMMATION TECHN'
     2,'IQUE", J. ACM, 1964'/1X,'VOL.11, (4), PP.400 - 415.'//)
      END
C
C                SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION DEXP,F
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=-(XT(1)-1.D0)*(XT(1)-1.D0)
      F=F-(XT(2)*XT(2)-.5D0)*(XT(2)*XT(2)-.5D0)/.132D0
      F=-(DEXP(F))
      RETURN
      END
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=.2D0
      XMIN(2)=.2D0
      XMAX(1)=2.D0
      XMAX(2)=2.D0
      RETURN
      END
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
C
      XX(1)=XT(1)*XT(1)+XT(2)*XT(2)
      XXMAX(1)=4.D0
      XXMIN(1)=-99999.D0
      RETURN
      END
