C
C
C
C                MAIN PROGRAMME FOR PROBLEM "C2M_V1.FOR"
C
C     C - CONSTRAINED
C
C     H. H. ROSENBROCK: "AN AUTOMATIC METHOD FOR FINDING THE GREATEST OR
C                     THE LEAST VALUE OF A FUNCTION", COMPUTER J., 1960,
C                     VOL.3, PP.175-184.
C
      DOUBLE PRECISION C(3),FF(6),H(18),XDN(3),XG(3),XMAX(3),XMIN(3),
     1XT(3),XUP(3),XX(1),XXMAX(1),XXMIN(1),OLDCC(3)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=10.D0
      XT(2)=10.D0
      XT(3)=10.D0
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-8
      ICON=5
      LIMIT=6000
      KNT=25
      N=3
      NIC=1
      K=6
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT( 5X,'OPTIMIZATION OF TEST PROBLEM: "C2M_V1.FOR"'//)
  998 FORMAT(1X,'H. H. ROSENBROCK: "AN AUTOMATIC METHOD FOR FINDING THE G
     1REATEST OR'/1X,'LEAST VALUES OF A FUNCTION", COMPUTER J.,1960,VOL.
     233,PP. 175-184.'//)
      END
C
C             SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(3)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=-(XT(1)*XT(2)*XT(3))
      RETURN
      END
C
C             SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N,NFUNC
      DOUBLE PRECISION XMAX(3),XMIN(3),XT(3)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        XMIN(1)=0.D0
        XMIN(2)=0.D0
        XMIN(3)=0.D0
        XMAX(1)=20.D0
        XMAX(2)=11.D0
        XMAX(3)=42.D0
      ELSE
        IF (XT(1) .GT. 0.D0) THEN
          XMAX(1)=1.001D0*XT(1)
            IF (XMAX(1) .GT. 20.D0) THEN
              XMAX(1)=20.D0
            ENDIF
        ELSE
          XMAX(1)=1.D-1
        ENDIF
        IF (XT(2) .GT. 0.D0) THEN
          XMAX(2)=1.001D0*XT(2)
            IF (XMAX(2) .GT. 11.D0) THEN
              XMAX(2)=11.D0
            ENDIF
        ELSE
          XMAX(2)=1.D-1
        ENDIF
        IF (XT(3) .GT. 0.D0) THEN
          XMAX(3)=1.001D0*XT(3)
            IF (XMAX(3) .GT. 42.D0) THEN
              XMAX(3)=42.D0
            ENDIF
        ELSE
          XMAX(3)=1.D-1
        ENDIF
      ENDIF
      RETURN
      END
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(3)
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)+XT(2)+XT(3)+XT(3)
      XXMAX(1)=72.D0
      XXMIN(1)=0.D0
      RETURN
      END
