C
C
C
C              MAIN PROGRAM FOR PROBLEM "C4_V1.FOR"
C
C     SCHWEFEL, H: "NUMERICAL OPTIMIZATION OF COMPUTER MODELS",WILEY 1981,
C                PAGE 326, PROBLEM 3.5.
C
      DOUBLE PRECISION C(20),FF(21),H(420),
     1XDN(20),XG(20),XMAX(20),XMIN(20),XT(20),XUP(20),XX(1),XXMAX(1),
     2XXMIN(1),OLDCC(20)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
      N=20
      DO 100 I=1, N
        XT(I)=1.D0
  100 CONTINUE
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-15
      ICON=5
      LIMIT=200000
      KNT=25
      NIC=1
      K=21
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  110 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,
     2XUP,XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 110
  999 FORMAT(1X,'OPTIMIZATION OF TEST PROBLEM: "C4_V1.FOR"'//)
  998 FORMAT(5X,'H. P. SCHWEFEL: "NUMERICAL OPTIMISATION OF COMPUTER ',
     1'MODELS",'/1X,'JOHN WILEY, 1981, PROBLEMS 2.21 AND 3.5 PAGES ',
     2'306 AND 326 RSPCTVLY'/1X,'THE ORIGINAL PROBLEMS ARE UNCONSTR',
     3'AINED. DUMMY EXPLICIT AND IMPLICIT'/1X,'CONSTRAINTS HAVE BEE',
     4'N INTRODUCED FOR COMPATIBILITY WITH THE SUBROUTINE.'//)
      END
C
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER I,KOUNT,KUT,N
      DOUBLE PRECISION AXT,DABS,F
      DOUBLE PRECISION XT(1)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=-1.D30
      DO 100 I=1, N
        AXT=DABS(XT(I))
          IF (AXT .GT. F) THEN
            F=AXT
          ENDIF
  100 CONTINUE
      F=F+1.D0
      RETURN
      END
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER I,IFLG,ISKP,KKT,KOUNT,N
      DOUBLE PRECISION XMAX(1),XMIN(1),XT(1)
C     
      KOUNT=KOUNT+1
      KKT=KKT+1
      DO 100 I=1, N
        XMIN(I)=-1.01D0
        XMAX(I)=1.01D0
  100 CONTINUE
      RETURN
      END
C
C             SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER I,KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(1)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=0.D0
      DO 100 I=1, N
        XX(1)=XX(1)+XT(I)
  100 CONTINUE
      XXMAX(1)=21.D0
      XXMIN(1)=-21.D0
      RETURN
      END
