C
C
C
C               MAIN PROGRAM FOR PROBLEM "C5_V1.FOR"
C
C  SCHWEFEL, H: 'NUMERICAL OPTIMISATION OF COMPUTER MODELS", WILEY 1981,
C                PAGE 327, PROBLEM 3.6. MODIFIED.  AN IMPLICIT CONSTRAINT
C                IS INTRODUCED WHICH IS ACTIVE AT ITS LOWER BOUND.
C
C
      DOUBLE PRECISION C(20),FF(21),H(420),XDN(20),XG(20),XMAX(20),
     1XMIN(20),XT(20),XUP(20),XX(1),XXMAX(1),XXMIN(1),OLDCC(20)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      N=20
      DO 100 I=1, N
        XT(I)=1.D0
  100 CONTINUE
C
C     CONTROL PARAMETERS FOR EVOP
      ALPHA=1.1D0
      BETA=.6D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-11
      ICON=5
      LIMIT=6000
      KNT=25
      NIC=1
      K=21
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  110 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 110
  999 FORMAT(1X,'OPTIMIZATION OF TEST PROBLEM: "C5_V1.FOR"'//)
  998 FORMAT(5X,'H. P. SCHWEFEL: "NUMERICAL OPTIMIZATION OF COMPUTER ',
     1'MODELS",'/1X,'JOHN WILEY, 1981, PROBLEMS 2.22 AND 3.6 PAGES ',
     2'306 AND 327 RESPCTVLY.'/1X,'THE ORIGINAL PROBLEMS ARE UNCONS',
     3'TRAINED. AN ACTIVE IMPLICIT'/1X,'CONSTRAINT HAS BEEN INTRODU',
     4'CED BY DR. S. N. GHANI TO MAKE THE PROBLEM EVEN MORE PATHOLO',
     5'GICAL.'//)
      END
C
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION DABS,F
      DOUBLE PRECISION XT(1)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=DABS(XT(1))
      DO 100 I=2, N
        F=F*DABS(XT(I))
  100 CONTINUE
      DO 110 I=1, N
        F=F+DABS(XT(I))
  110 CONTINUE
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(1),XMIN(1),XT(1)
C     
      KOUNT=KOUNT+1
      KKT=KKT+1
      DO 100 I=1, N
        XMAX(I)=1.01D0
        XMIN(I)=-1.01D0
  100 CONTINUE
      RETURN
      END
C
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(1)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=0.D0
      DO 100 I=1, N
        XX(1)=XX(1)+XT(I)
  100 CONTINUE
      XXMAX(1)=21.D0
      XXMIN(1)=5.D0
      RETURN
      END
