C
C
C
C               MAIN PROGRAM FOR PROBLEM "C6_V1.FOR"
C
C     C - CONSTRAINED
C
C     H. P. SCHWEFEL: "NUMERICAL OPTIMISATION OF COMPUTER MODELS",
C                    JOHN WILEY, 1981, PROBLEMS 2.21 AND 3.5 PAGES
C                    306 - 326 RESPECTIVELY.
C     THE ORIGINAL PROBLEMS ARE UNCONSTRAINED. ACTIVE EXPLICIT AND
C     IMPLICIT CONSTRAINTS HAVE BEEN INTRODUCED BY DR. S. N. GHANI.
C     IN ORDER TO EXPEDITE CONVERGENCE MOVING UPPER BOUNDARY FORMS A
C     PART OF THE EXPLICIT CONSTRAINTS.
C
      DOUBLE PRECISION C(20),FF(21),H(420),XDN(20),XG(20),XMAX(20),
     1XMIN(20),XT(20),XUP(20),XX(1),XXMAX(1),XXMIN(1),OLDCC(20)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      N=20
      DO 100 I=1, N
        XT(I)=10.D0
  100 CONTINUE
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=.4D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-8
      ICON=5
      LIMIT=120000
      KNT=25
      NIC=1
      K=21
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  110 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 110
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "C6_V1.FOR"'//)
  998 FORMAT(5X,'H. P. SCHWEFEL: "NUMERICAL OPTIMISATION OF COMPUTER ',
     1'MODELS",'/1X,'JOHN WILEY, 1981, PROBLEMS 2.21 AND 3.5 PAGES ',
     2'306 AND 326 RSPCTVLY.'/1X,'THE ORIGINAL PROBLEMS ARE UNCONST',
     3'RAINED. ACTIVE EXPLICIT AND'/1X,'IMPLICIT CONSTRAINTS HAVE ',
     4'BEEN INTRODUCED BY DR S. N. GHANI. IN ORDER'/1X,'TO EXPEDITE',
     5'CONVERGENCE MOVING BOUNDARIES FORM PART OF EXPLICIT CONSTRAI',
     6'NTS.'//)

      END
C
C
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER I,KOUNT,KUT,N
      DOUBLE PRECISION AXT,DABS,F
      DOUBLE PRECISION XT(1)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=-1.D30
      DO 100 I=1, N
        AXT=DABS(XT(I))
        IF (AXT .GT. F) THEN
          F=AXT
        ENDIF
  100 CONTINUE
      RETURN
      END
C
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER I,IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(1),XMIN(1),XT(1)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      DO 100 I=1, N
        XMIN(I)=.25D0
        XMAX(I)=10.1D0
  100 CONTINUE
      RETURN
      END
C
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS.
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER I,KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(1)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=0.D0
      DO 100 I=1, N
        XX(1)=XX(1)+XT(I)
  100 CONTINUE
      XXMAX(1)=201.D0
      XXMIN(1)=5.D0
      RETURN
      END
