C
C
C              MAIN PROGRAM FOR PROBLEM "EC1_V1.FOR"
C
C      EC - EQUALITY CONSTRAINED
C
C      K.SCHITTKOWSKI: "MORE TEST EXAMPLES FOR NONLINEAR PROGRAMMING
C                       CODES", SPRINGER-VERLAG, 1987, LECTURE NOTES
C                       IN ECONOMICS AND MATHEMATICAL SYSTEMS, VOL.
C                       282, P.166 (A BOOK).
C      THE PROBLEM HAS BEEN SLIGHTLY MODIFIED BY DR. S. N. GHANI FOR
C      COMPATIBLITY WITH SUBROUTINE "EVOP".
C
      DOUBLE PRECISION C(4),FF(8),H(32),OLDCC(4),XDN(4),XG(4),XMAX(4),
     1XMIN(4),XT(4),XUP(4),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=0.D0
      XT(2)=0.D0
      XT(3)=2.D0
      XT(4)=1.D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.3D0
      BETA=0.3D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-9
      ICON=5
      LIMIT=6000
      KNT=25
      N=4
      NIC=1
      K=8
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "EC1_V1.FOR".'//)
  998 FORMAT(1X,'K. SCHITTKOWSKI: "MORE TEST EXAMPLES FOR NON',
     1'LINEAR PROGRAMMING,'/1X,'CODES", SPRINGER-VERLAG, 1987,',
     2' LECTURE NOTES IN ECONOMICS AND MATHEMATICAL SYSTEMS,',
     3' VOL.282, P.166 (A BOOK).'/1X,'THE PROBLEM HAS BEEN SLIG',
     4'HTLY MODIFIED BY DR. S. N. GHANI FOR COMPATIBILITY ',
     5'WITH SUBROUTINE "EVOP".'//)
      END
C
C
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION DSQRT,F
      DOUBLE PRECISION XT(4)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=(XT(1)-1.D0)*(XT(1)-1.D0)+(XT(1)-XT(2))*(XT(1)-XT(2))
      F=F+(XT(2)-XT(3))*(XT(2)-XT(3))*(XT(2)-XT(3))*(XT(2)-XT(3))
      F=F+XT(4)*(XT(1)*(1.D0+XT(2)*XT(2))+XT(3)*XT(3)*XT(3)*XT(3))
      F=F-XT(4)*(4.D0+3.D0*DSQRT(2.D0))
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(4),XMIN(4),XT(4)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=0.D0
      XMIN(2)=0.D0
      XMIN(3)=0.D0
      XMIN(4)=0.D0
      XMAX(1)=2.D0
      XMAX(2)=2.D0
      XMAX(3)=2.D0
      XMAX(4)=4.D0
      RETURN
      END
C
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION DSQRT
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(4)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)*(1.D0+XT(2)*XT(2))
      XX(1)=XX(1)+XT(3)*XT(3)*XT(3)*XT(3)-4.D0-3.D0*DSQRT(2.D0)
      XXMAX(1)=10.D0
      XXMIN(1)=0.D0
      RETURN
      END
