c
C
C             MAIN PROGRAM FOR PROBLEM "EC2_V1.FOR"
C
C      EC - EQUALITY CONSTRAINED
C
C      K.SCHITTKOWSKI: "MORE TEST EXAMPLES FOR NONLINEAR PROGRAMMING
C                       CODES", SPRINGER-VERLAG, 1987, LECTURE NOTES
C                       IN ECONOMICS AND MATHEMATICAL SYSTEMS, VOL.
C                       282, P.173 (A BOOK).
C      THE PROBLEM HAS BEEN SLIGHTLY MODIFIED BY DR. S. N. GHANI FOR
C      COMPATIBILITY WITH SUBROUTINE "EVOP".
C
C
      DOUBLE PRECISION C(5),FF(10),H(50),OLDCC(5),XDN(5),XG(5),XMAX(5),
     1XMIN(5),XT(5),XUP(5),XX(3),XXMAX(3),XXMIN(3)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C        STARTING POINT FOR OPTIMISATION
      XT(1)=0.D0
      XT(2)=0.D0
      XT(3)=.397519652D0
      XT(4)=.600317377D0
      XT(5)=1.D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.1D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-8
      PHICPX=1.D-9
      ICON=5
      LIMIT=50000
      KNT=25
      N=5
      NIC=3
      K=10
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "EC2_V1.FOR".'//)
  998 FORMAT(1X,'K. SCHITTKOWSKI: "MORE TEST EXAMPLES FOR NO',
     1'NLINEAR PROGRAMMING'/1X,'CODES, SPRINGER-VERLAG, 1987,',
     2' LECTURE NOTES IN ECONOMICS AND'/1X,'MATHEMATICAL SYSTEMS,',
     3' VOL.282, P.173 (A BOOK).'/1X,'THE PROBLEM HAS BEEN SLIGH',
     4'TLY MODIFIED BY DR. S. N. GHANI FOR'/1X,
     5'COMPATIBILITY WITH SUBROUTINE "EVOP".'//)
      END
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(5)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=24.55D0*XT(1)+26.75D0*XT(2)+39.D0*XT(3)+40.5D0*XT(4)
      F=-(F)+XT(5)*(XT(1)+XT(2)+XT(3)+XT(4)-1.D0)
      RETURN
      END
C
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(5),XMIN(5),XT(5)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=0.D0
      XMIN(2)=0.D0
      XMIN(3)=0.D0
      XMIN(4)=0.D0
      XMIN(5)=0.D0
      XMAX(1)=1.D0
      XMAX(2)=1.D0
      XMAX(3)=1.D0
      XMAX(4)=1.D0
      XMAX(5)=4.D0
      RETURN
      END
C
C
C               SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION DSQRT
      DOUBLE PRECISION XX(3),XXMAX(3),XXMIN(3),XT(5)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=2.3D0*XT(1)+5.6D0*XT(2)+11.1D0*XT(3)+1.3D0*XT(4)
      XX(3)=.53D0*XT(1)*.53D0*XT(1)+.44D0*XT(2)*.44D0*XT(2)+4.5D0*XT
     1  (3)*4.5D0*XT(3)
      XX(3)=XX(3)+.79D0*XT(4)*.79D0*XT(4)
      XX(2)=12.D0*XT(1)+11.9D0*XT(2)+41.8D0*XT(3)+52.1D0*XT(4)-1.645D0
     1  *DSQRT(XX(3))
      XX(3)=XT(1)+XT(2)+XT(3)+XT(4)-1.D0
      XXMAX(1)=5.5D0
      XXMIN(1)=5.D0
      XXMAX(2)=45.300864D0
      XXMIN(2)=12.D0
      XXMAX(3)=0.D0
      XXMIN(3)=-.5D0
      RETURN
      END
