C
C
C
C              MAIN PROGRAM FOR PROBLEM "MM1M_V1.FOR"
C
C     MM - MULTIPLE MINIMA
C
C     A. A. GOLDSTEIN AND J. F. PRICE: "ON DESCENT FROM LOCAL MINIMA",
C           MATHEMATICS OF COMPUTATION, 1971, VOL.25, (115),
C           PP.569-574.
C
      DOUBLE PRECISION C(2),FF(4),H(8),OLDCC(2),XDN(2),XG(2),XMAX(2),
     1XMIN(2),XT(2), XUP(2),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=4.3D0
      XT(2)=2.5D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-11
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MM1M_V1.FOR".'//)
  998 FORMAT('A. A. GOLDSTEIN AND J. F. PRICE: "ON DESCENT ',
     1'FROM LOCAL MINIMA",'/1X,'MATHEMATICS OF COMPUTATION,',
     2' 1971, VOL.25, (115), PP.569-574.'//)
      END
C
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION A,B,CF,DEXP,DSIN,F
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      A=XT(1)*XT(1)+XT(2)*XT(2)-25.D0
      A=.25D0*A*A
C           FOR 'A' GREATER THAN '88'  DEXP(A) BELOW CRASHES FOR VAX COMPUTERS
      IF (A .GT. 88.0D0) A=88.0D0
      B=XT(1)+XT(1)+XT(1)+XT(1)-XT(2)-XT(2)-XT(2)
      CF=XT(1)+XT(1)+XT(2)-10.D0
      CF=CF*CF
      F=DSIN(B)
      F=F*F*F*F
      F=F+DEXP(A)+.5D0*CF
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N,NFUNC
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        DO 109 I=1, N
          XMAX(I)=5.D0
          XMIN(I)=-1.D0
  109   CONTINUE
      ELSE
        DO 120 I=1, N
          IF (XT(I) .LT. 0.D0) THEN
            XMIN(I)=1.001D0*XT(I)
            XMAX(I)=0.D0
            IF (XMIN(I) .LT. -1.D0) THEN
              XMIN(I)=-1.D0
            ENDIF
          ENDIF
          IF (XT(I) .GT. 0.D0) THEN
            XMIN(I)=0.D0
            XMAX(I)=1.001D0*XT(I)
            IF (XMAX(I) .GT. 5.D0) THEN
              XMAX(I)=5.D0
            ENDIF
          ENDIF
  120   CONTINUE
      ENDIF
      RETURN
      END
C
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION A
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
      A=XT(1)*XT(1)+XT(2)*XT(2)-25.D0
      A=.25D0*A*A
      XX(1)=A
      XXMAX(1)=174.673D0
      XXMIN(1)=-180.2182D0
      RETURN
      END
