C
C
C
C              MAIN PROGRAM FOR PROBLEM "MM2_V1.FOR"
C
C     MM - MULTIPLE MINIMA
C
C     A. A. GOLDSTEIN AND J. F. PRICE: "ON DESCENT FROM LOCAL MINIMA",
C              MATHEMATICS OF COMPUTATION, 1971, VOL.25, (115),
C              PP.569-574.
C
      DOUBLE PRECISION C(2),FF(4),H(8),OLDCC(2),XDN(2),XG(2),XMAX(2),
     1XMIN(2),XT(2), XUP(2),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9, 999)
      WRITE(9, 998)
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=-1.2D0
      XT(2)=1.D0
C
C
C         CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.3D0
      BETA=.7D0
      GAMA=1.5D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-10
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=10
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MM2_V1.FOR".'//)
  998 FORMAT(1X,'A. A. GOLDSTEIN AND J. F. PRICE: "ON DESCENT',
     1' FROM LOCAL MINIMA",'/1X,'MATHEMATICS OF COMPUTATION, ',
     2'1971, VOL.25, (115), PP. 569-574.'//)
      END
C
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F,FA
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=18.D0-32.D0*XT(1)+12.D0*XT(1)*XT(1)+48.D0*XT(2)
      F=F-36.D0*XT(1)*XT(2)+27.D0*XT(2)*XT(2)
      F=F*(XT(1)+XT(1)-XT(2)-XT(2)-XT(2))
      F=F*(XT(1)+XT(1)-XT(2)-XT(2)-XT(2))+30.D0
      FA=-14.D0*XT(1)+3.D0*XT(1)*XT(1)-14.*XT(2)
      FA=FA+6.D0*XT(1)*XT(2)+3.D0*XT(2)*XT(2)+19.D0
      FA=FA*(XT(1)+XT(2)+1.D0)*(XT(1)+XT(2)+1.D0)+1.D0
C             VAX COMPUTERS CANNOT COPE WITH NUMBERS MUCH BIGGER THAN 1.0E38
      IF (F .GT. 1.0D19) F=1.0D19
      IF (FA .GT. 1.0D19) FA=1.0D19
      F=F*FA
      RETURN
      END
C
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=-1.D5
      XMIN(2)=-1.D5
      XMAX(1)=1.D5
      XMAX(2)=1.D5
      RETURN
      END
C
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)
      XXMAX(1)=1.D5
      XXMIN(1)=-1.D5
      RETURN
      END
