C
C
C
C              MAIN PROGRAM FOR PROBLEM "MM3_V1.FOR"
C
C
C     MM - MULTIPLE MINIMA
C
C     L. C. W. DIXON AND G. P. SZEGO (EDS): "TOWARDS GLOBAL MINIMISATION",
C           NORTH HOLLAND PUBLISHING CO., 1975 (TRECCANI).
C
      DOUBLE PRECISION C(2),FF(4),H(8),OLDCC(2),XDN(2),XG(2),XMAX(2),
     1XMIN(2),XT(2),XUP(2),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=-1.2D0
      XT(2)=1.D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-11
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MM3_V1.FOR".'//)
  998 FORMAT(1X,'L.C. W. DIXON AND G. P. SZEGO (EDS):',
     1' "TOWARDS GLOBAL MINIMISATION",'/1X,'NORTH HOL',
     2'LAND PUBLISHING CO., 1975  (TRECCANI).'//)
      END
C
C
C               SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=XT(1)*XT(1)*XT(1)*XT(1)
      F=F+4.D0*XT(1)*XT(1)*XT(1)
      F=F+4.D0*XT(1)*XT(1)
      F=F+XT(2)*XT(2)+1.D0
      RETURN
      END
C
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      XMIN(1)=-1.D5
      XMIN(2)=-1.D5
      XMAX(1)=1.D5
      XMAX(2)=1.D5
      RETURN
      END
C
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)
      XXMAX(1)=1.D5
      XXMIN(1)=-1.D5
      RETURN
      END
