C
C
C
C              MAIN PROGRAM FOR PROBLEM "MM4M_V1.FOR"
C
C     MM - MULTIPLE MINIMA WITH MOVING BOUNDARY.
C
C     AIMO TORN AND ANTANAS ZILINSKAS: `GLOBAL OPTIMIZATION', PAGE 186,
C     HE - HESSE [HESSE 1973], (N=6), VOLUME 350, SPRINGER-VERLAG,
C     1987, ISBN 3-540-50871-6 AND ISBN 0-387-50871-6.
C
C     MOVING BOUNDARY HAS BEEN INTRODUCED BY DR. S. N. GHANI.
C
C
C
      DOUBLE PRECISION C(6),FF(7),H(42),OLDCC(6),XDN(6),XG(6),
     1XMAX(6),XMIN(6),XT(6),XUP(6),XX(5),XXMAX(5),XXMIN(5)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=1.875D0
      XT(2)=0.375D0
      XT(3)=5.D0
      XT(4)=0.95D0
      XT(5)=5.D0
      XT(6)=8.D0
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=0.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-8
      PHICPX=1.D-7
      ICON=5
      LIMIT=60000
      KNT=25
      N=6
      NIC=5
      K=7
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MM4M_V1.FOR."'//)
  998 FORMAT(1X,'A. TORN AND A. ZILINSKAS: "GLOBAL OPTIMIZATION"',/,
     1' PAGE 186, HE - HESSE, VOLUME 350, SPRINGER VERLAG, 1987.'///)
      END
C
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(6)
C       
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=25.D0*(XT(1)-2.D0)*(XT(1)-2.D0)+(XT(2)-2.D0)*(XT(2)-2.D0)
      F=F+(XT(3)-1.D0)*(XT(3)-1.D0)+(XT(4)-4.D0)*(XT(4)-4.D0)
      F=F+(XT(5)-1.D0)*(XT(5)-1.D0)+(XT(6)-4.D0)*(XT(6)-4.D0)
      F=-F
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(6),XMIN(6),XT(6)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        XMIN(1)=0.D0
        XMIN(2)=0.D0
        XMIN(3)=1.D0
        XMIN(4)=0.D0
        XMIN(5)=1.D0
        XMIN(6)=0.D0
        XMAX(1)=1000.D0
        XMAX(2)=1000.D0
        XMAX(3)=5.D0
        XMAX(4)=6.D0
        XMAX(5)=5.D0
        XMAX(6)=10.D0
      ELSE
        XMIN(1)=0.D0
C       IF (XT(1) .GT. 0.D0) THEN
C         XMAX(1)=1.001D0*XT(1)
C         IF (XMAX(1) .GT. 1000.D0) THEN
            XMAX(1)=1000.D0
C         ENDIF
C       ELSE
C         XMAX(1)=1.D-1
C       ENDIF
        XMIN(2)=0.D0
C       IF (XT(2) .GT. 0.D0) THEN
C         XMAX(2)=1.001D0*XT(2)
C         IF (XMAX(2) .GT. 1000.D0) THEN
            XMAX(2)=1000.D0
C         ENDIF
C       ELSE
C         XMAX(2)=1.D-1
C       ENDIF
        XMIN(3)=1.D0
C       IF (XMAX(3) .GT. 1.D0) THEN
C         XMAX(3)=1.001D0*XT(3)
C         IF (XMAX(3) .GT. 5.D0) THEN
            XMAX(3)=5.D0
C         ENDIF
C       ELSE
C         XMAX(3)=1.1D0
C       ENDIF
        XMIN(4)=0.D0
C       IF (XT(4) .GT. 0.D0) THEN
C         XMAX(4)=1.001D0*XT(4)
C         IF (XMAX(4) .GT. 6.D0) THEN
            XMAX(4)=6.D0
C         ENDIF
C       ELSE
C         XMAX(4)=1.D-1
C       ENDIF
        XMIN(5)=1.D0
        IF (XT(5) .GT. 1.D0) THEN
          XMAX(5)=1.001D0*XT(5)
          IF (XMAX(5) .GT. 5.D0) THEN
            XMAX(5)=5.D0
          ENDIF
        ELSE
          XMAX(5)=1.1D0
        ENDIF
        XMIN(6)=0.D0
        IF (XT(6) .GT. 0.D0) THEN
          XMAX(6)=1.001D0*XT(6)
          IF (XMAX(6) .GT. 10.D0) THEN
            XMAX(6)=10.D0
          ENDIF
        ELSE
          XMAX(6)=1.D-1
        ENDIF
      ENDIF
      RETURN
      END
C
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(5),XXMAX(5),XXMIN(5),XT(6)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)
      XX(2)=-XT(1)+XT(2)
      XX(3)=XT(1)-XT(2)-XT(2)-XT(2)
      XX(4)=(XT(3)-3.D0)*(XT(3)-3.D0)+XT(4)
      XX(5)=(XT(5)-3.D0)*(XT(5)-3.D0)+XT(6)
      XXMIN(1)=2.D0
      XXMIN(2)=-1000.D0
      XXMIN(3)=-1000.D0
      XXMIN(4)=4.D0
      XXMIN(5)=4.D0
      XXMAX(1)=6.D0
      XXMAX(2)=2.D0
      XXMAX(3)=2.D0
      XXMAX(4)=1000.D0
      XXMAX(5)=1000.D0
      RETURN
      END
