C
C
C
C              MAIN PROGRAM FOR PROBLEM "MM7M_V1.FOR"
C
C     MM - MULTIPLE MINIMA AND MOVING BOUNDARIES.
C
C     AIMO TORN AND ANTANAS ZILINSKAS: `GLOBAL OPTIMIZATION', PAGE 186,
C     Gn - GRIEWANK [GRIEWANK 1981], (N=10), VOLUME 350, SPRINGER-VERLAG,
C     1987, ISBN 3-540-50871-6 AND ISBN 0-387-50871-6.
C
C
C
      DOUBLE PRECISION C(10),FF(11),H(110),OLDCC(10),XDN(10),XG(10),
     1XMAX(10),XMIN(10),XT(10),XUP(10),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
      WRITE(9,999)
      WRITE(9,998)
C
C
C      STARTING POINT FOR OPTIMISATION
      N=10
      DO 10 I=1,N
        XT(I)=10.D0
   10 CONTINUE
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.1D0
      BETA=.6D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-9
      PHICPX=1.D-10
      ICON=5
      LIMIT=60000
      KNT=25
      NIC=1
      K=11
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MM7M_V1.FOR".'//)
  998 FORMAT(1X,'A. TORN AND A. ZILINSKAS: "GLOBAL OPTIMIZATION"',/, 
     1' PAGE 186, Gn - GRIEWANK, VOLUME 350, SPRINGER VERLAG, 1987.'///)
      END
C
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION DCOS,DFLOAT,DSQRT,F,F2
      DOUBLE PRECISION XT(10)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=0.D0
      DO 10 I=1,N
        F=F+XT(I)*XT(I)
   10 CONTINUE
      F=F/4.D3
      F2=1.D0
      DO 20 I=1,N
        F2=F2*DCOS(XT(I)/DSQRT(DFLOAT(I)))
   20 CONTINUE
      F=F-F2+2.D0
      RETURN
      END
C
C
C               SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N
      DOUBLE PRECISION XMAX(10),XMIN(10),XT(10)
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        DO 100 I=1,N
          XMIN(I)=-6.D2
          XMAX(I)=6.D2
  100   CONTINUE
      ELSE
        DO 110 I=1, N
          IF (XT(I) .LT. 0.D0) THEN
            XMIN(I)=1.D4*XT(I)
            XMAX(I)=0.D0
            IF (XMIN(I) .LT. -6.D2) THEN
                XMIN(I)=-6.D2
            ENDIF
          ENDIF
          IF (XT(I) .GT. 0.D0) THEN
            XMIN(I)=0.D0
            XMAX(I)=1.D4*XT(I)
            IF (XMAX(I) .GT. 6.D2) THEN
              XMAX(I)=6.D2
             ENDIF
          ENDIF
  110   CONTINUE
      ENDIF
      RETURN
      END
C
C
C              SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(10)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=0.D0
      DO 10 I=1,N
        XX(1)=XX(1)+XT(I)
   10 CONTINUE
      XXMIN(1)=-6.D3
      XXMAX(1)=6.D3
      RETURN
      END
