C
C
C
C              MAIN PROGRAM FOR PROBLEM "MV2M_V1.FOR"
C
C     MV - MIXED VARIABLE TYPES
C
C       SAME AS PROBLEM "MV2_V1.FOR" BUT WITH MOVING EXPLICIT CONSTRAINTS
C       TO EXPIDITE CONVERGENCE. 
C      
C     MODIFICATIONS INTRODUCED BY DR. S. N. GHANI.  
C
      DOUBLE PRECISION C(3),FF(6),H(18),OLDCC(3),XDN(3),XG(3),XMAX(3),
     1XMIN(3),XT(3),XUP(3),XX(1),XXMAX(1),XXMIN(1)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
C
C
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
      XT(1)=10.D0
      XT(2)=10.D0
      XT(3)=10.D0
C
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.3D0
      BETA=.5D0
      GAMA=2.D0
      DEL=1.D-12
      PHI=1.D-10
      PHICPX=1.D-8
      ICON=5
      LIMIT=60000
      KNT=25
      N=3
      NIC=1
      K=6
      IPRINT=2
      IJK=1
      NRSTRT=2
      IMV=0
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,XUP,
     2XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "MV2M_V1.FOR"'//)
  998 FORMAT(1X,'SAME AS "C2M_V1.FOR" BUT VARIABLE "XT(1)" ALLOWED',
     1' TO TAKE ONLY NEAR'/1X,'INTEGER VALUES AND VARIABLE XT(2) NEAR'
     2' PREDEFINED DISCRETE VALUES'//' MODIFICATIONS',
     4' INTRODUCED BY DR. S. N. GHANI.'//)  
      END
C
C              SUBROUTINE FOR FUNCTION VALUE
C
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(3)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=-(XT(1)*XT(2)*XT(3))
      RETURN
      END
C
C             SUBROUTINE FOR EXPLICIT CONSTRAINTS
C
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N,NFUNC
      DOUBLE PRECISION DX(10),XMAX(3),XMIN(3),XT(3)
      DOUBLE PRECISION STRIP
C
      KOUNT=KOUNT+1
      KKT=KKT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        XMIN(1)=.0000001D0
        XMIN(2) =.00000015D0
        XMIN(3) =0.D0
        XMAX(1) =20.01D0
        XMAX(2) =11.01D0
        XMAX(3) =42.D0
      ELSE
        XMIN(1)=0.0000001D0
        XMIN(2)=0.00000015D0
        XMAX(1)=20.01D0
        XMAX(2)=11.01D0
        XMIN(3)=0.D0
        IF (XT(3) .GT. 0.D0) THEN
          XMAX(3)=1.001D0*XT(3)
          IF (XMAX(3) .GT. 42.D0) THEN
            XMAX(3)=42.D0
          ENDIF
        ELSE
          XMAX(3)=1.D-1
        ENDIF
      ENDIF
      IF (IFLG .EQ. 0) THEN
        STRIP=1.D-4
        CALL DINTG2(ISKP,STRIP,XT(1),XMAX(1),XMIN(1))
        DX(1)=.1D0
        DX(2)=.8D0
        DX(3)=1.5D0
        DX(4)=1.9D0
        DX(5)=3.5D0
        DX(6)=6.2D0
        DX(7)=8.1D0
        DX(8)=9.2D0
        DX(9)=10.5D0
        DX(10)=11.D0
        CALL DISCR2(DX,ISKP,10,STRIP,XT(2),XMAX(2),XMIN(2))
      ENDIF
      RETURN
      END
C
C             SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(3)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)+XT(2)+XT(3)+XT(3)
      XXMAX(1)=72.D0
      XXMIN(1)=0.D0
      RETURN
      END
