C
C
C              MAIN PROGRAMME FOR PROBLEM "UC1M_V1.FOR"
C
C     UC - UNCONSTRAINED
C
C       SAME AS PROBLEM "UC1_V1.FOR" BUT WITH MOVING EXPLICIT 
C       CONSTRAINTS. MODIFICATIONS INTRODUCED BY DR. S. N. GHANI.
C
C
      DOUBLE PRECISION C(2),FF(4),H(8),XDN(2),XG(2),XMAX(2),XMIN(2),
     1XT(2),XUP(2),XX(1),XXMAX(1),XXMIN(1),OLDCC(2)
C
      DOUBLE PRECISION ALPHA,BETA,DEL,GAMA,PHI,PHICPX
C
      INTEGER ICON,IJK,IMV,IPRINT,K,KNT,LIMIT,N,NRSTRT,NIC
      WRITE(9,999)
      WRITE(9,998)
C
C      STARTING POINT FOR OPTIMISATION
C
      XT(1)=-1.2D0
      XT(2)=1.0D0
C
C     CONTROL PARAMETERS FOR "EVOP"
      ALPHA=1.2D0
      BETA=0.5D0
      GAMA=2.0D0
      DEL=1.0D-12
      PHI=1.0D-10
      PHICPX=1.0D-11
      ICON=5
      LIMIT=6000
      KNT=25
      N=2
      NIC=1
      K=4
      IPRINT=2
      NRSTRT=2
      IMV=0
      IJK=1
  100 CALL EVOP(ALPHA,BETA,C,DEL,FF,GAMA,H,ICON,IJK,IMV,IPRINT,K,
     1KNT,LIMIT,N,NRSTRT,NIC,OLDCC,PHI,PHICPX,XDN,XG,XMAX,XMIN,XT,
     2XUP,XX,XXMAX,XXMIN)
      IF (IJK .LT. 9) GOTO 100
  999 FORMAT(5X,'OPTIMIZATION OF TEST PROBLEM: "UC1M_V1.FOR"'//)
  998 FORMAT(1X,'H. H. ROSENBROCK: "AN AUTOMATIC METHOD FOR FINDING THE'
     1,' GREATEST OR LEAST'/1X,'VALUES OF A FUNCTION`, COMPUTER J., 196'
     2,'0 VOL.3, P.175 - 184.'//)
      END
C
C           SUBROUTINE FOR FUNCTION VALUE
      SUBROUTINE FUNC(F,KOUNT,KUT,N,XT)
C
      INTEGER KOUNT,KUT,N
      DOUBLE PRECISION F
      DOUBLE PRECISION XT(2)
C
      KOUNT=KOUNT+1
      KUT=KUT+1
      F=100.D0*((XT(1)*XT(1)-XT(2))*(XT(1)*XT(1)-XT(2)))
      F=F+(1.D0-XT(1))*(1.D0-XT(1))+1.D0
      RETURN
      END
C
C              SUBROUTINE FOR EXPLICIT CONSTRAINTS
      SUBROUTINE EXPCON(IFLG,ISKP,KKT,KOUNT,M,N,XMAX,XMIN,XT)
C
      INTEGER IFLG,ISKP,KKT,KOUNT,M,N,NFUNC
      DOUBLE PRECISION XMAX(2),XMIN(2),XT(2)
C
      KKT=KKT+1
      KOUNT=KOUNT+1
      NFUNC=KOUNT-KKT-M
      IF (NFUNC .LT. 2) THEN
        XMAX(1)=1.D5
        XMAX(2)=1.D5
        XMIN(1)=-1.D5
        XMIN(2)=-1.D5
      ELSE
        DO 120 I=1, 2
          IF (XT(I) .LT. 0.D0) THEN
            XMIN(I)=1.001D0*XT(I)
            XMAX(I)=0.D0
            IF (XMIN(I) .LT. -100000.D0) THEN
              XMIN(I)=-100000.D0
            ENDIF
          ENDIF
          IF (XT(I) .GT. 0.D0) THEN
            XMIN(I)=0.D0
            XMAX(I)=1.001D0*XT(I)
            IF (XMAX(I) .GT. 100000.D0) THEN
              XMAX(I)=100000.D0
            ENDIF
          ENDIF
  120   CONTINUE
      ENDIF
      RETURN
      END
C
C
C             SUBROUTINE FOR IMPLICIT CONSTRAINTS
C
      SUBROUTINE IMPCON(KOUNT,M,N,NIC,XT,XX,XXMAX,XXMIN)
C
      INTEGER KOUNT,M,N,NIC
      DOUBLE PRECISION XX(1),XXMAX(1),XXMIN(1),XT(2)
C
      KOUNT=KOUNT+1
      M=M+1
      XX(1)=XT(1)+XT(2)
      XXMAX(1)=100000.D0
      XXMIN(1)=-100000.D0
      RETURN
      END
